/* 
  Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
  All right reserved.
*/

#ifndef DEF_SOURCE_main_c
#define DEF_SOURCE_main_c "main.c"

static void __Putc__(int s_x, int s_y, int s_Color, int s_Char);
static void __Puts__(int s_x, int s_y, int s_Color, const char *s_String);

int main(void);

static void __Putc__(int s_x, int s_y, int s_Color, int s_Char)
{
 unsigned short *c_TextMap = (unsigned short *)0x000b8000lu;  
 c_TextMap[ (s_y * 80) + s_x ] = (s_Color << 8) | s_Char;
}

static void __Puts__(int s_x, int s_y, int s_Color, const char *s_String)
{
 int s_Index = 0;
 while(s_String[s_Index] != '\0')__Putc__(s_x++, s_y, s_Color, s_String[s_Index++]);
}

int main(void)
{
 int s_LoopCount, s_Char, s_x, s_y, s_Color;
 char s_HelloWorld[] = {'H', 'e', 'l', 'l', 'o', ' ', 'w', 'o', 'r', 'l', 'd', ' ', '!', '\0'};

 s_Char = 'a';
 for(s_LoopCount = 0;s_LoopCount < 100;s_LoopCount++)
 {
  for(s_y = 0;s_y < 25;s_y++)
  {
   for(s_x = 0;s_x < 80;s_x++)
   {
    __Putc__(s_x, s_y, 0x0e, s_Char);
   }
  }
  s_Char++;
  if(s_Char > 'z')s_Char = 'a';
 }
 for(s_y = 0;s_y < 25;s_y++)
 {
  for(s_x = 0;s_x < 80;s_x++)
  {
   __Putc__(s_x, s_y, 0x07, ' ');
  }
 }
 s_Color = 0;
 do
 {
  for(s_y = 0;s_y < 25;s_y++)
  {
   __Puts__(0, s_y, s_Color++, s_HelloWorld); 
   s_Color &= 0xff;
  }
 }while(1);

 return(0);
}

#endif

/* End of source */
