# Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
# All right reserved.

%.b:
	@$(ECHO) -e "[\x1b[1;47mBI\x1b[0m] $^ => $@ (Link binary)"
	@$(LD) $(DEF_LDFLAGS_BINARY) -e L_Entry -o $@ $^

%.lo:
	@$(ECHO) -e "[\x1b[1;36mLO\x1b[0m] $^ => $@ (Link object)"
	@$(LD) $(DEF_LDFLAGS_OBJECT) -o $@ $^

GNUC_%.o: %.c
	@$(ECHO) -e "[\x1b[1;34mCC\x1b[0m] $< => $@ (GNU-C)"
	@$(CC) $(DEF_CFLAGS_ANSI) -o $@ $<

ANSI_%.o: %.c
	@$(ECHO) -e "[\x1b[1;34mCC\x1b[0m] $< => $@ (ANSI-C)"
	@$(CC) $(DEF_CFLAGS_ANSI) -o $@ $<

ASM_%.o: %.s
	@$(ECHO) -e "[\x1b[1;34mAS\x1b[0m] $< => $@ (Assemble)"
	@$(AS) $(DEF_AFLAGS_AT_AND_T) -o $@ $<


# End of rules
