# Copyright (c) 2004 JaeHyuk Cho <mailto:minzkn@infoeq.com>
# All right reserved.

# = [ Build tools ] =
ECHO                         :=echo
AS                           :=as
AS86                         :=as86
CC                           :=cc
LD                           :=ld
AR                           :=ar
RM                           :=rm -f
MAKE                         :=make

# = [ Version ] =
DEF_ARCHITECTURE             :=i386
DEF_VERSION_MAJOR            :=0
DEF_VERSION_MINOR            :=0
DEF_VERSION_EXTRA            :=1
DEF_VERSION_BUILD            :=0
DEF_VERSION                  :=$(DEF_VERSION_MAJOR).$(DEF_VERSION_MINOR).$(DEF_VERSION_EXTRA) build $(DEF_VERSION_BUILD)

# = [ Build option ] =
DEF_AFLAGS_COMMON            :=
DEF_AFLAGS_AT_AND_T          :=$(DEF_AFLAGS_COMMON) $(DEF_INCLUDE_PATH)

DEF_CFLAGS_COMMON            :=-O2 -Wall -Werror -fomit-frame-pointer
DEF_CFLAGS_COMMON            += -mcpu=i586
DEF_CFLAGS_ANSI              :=$(DEF_CFLAGS_COMMON) $(DEF_INCLUDE_PATH) $(DEF_DEFINE) -ansi -c
DEF_CFLAGS_GNUC              :=$(DEF_CFLAGS_COMMON) $(DEF_INCLUDE_PATH) $(DEF_DEFINE) -c

DEF_LDFLAGS_EXEC             :=-s
DEF_LDFLAGS_OBJECT           :=-s -r
DEF_LDFLAGS_BINARY           :=-s -Ttext 0 --oformat binary

# End of rules
